<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_201) on Tue Jun 11 21:47:08 AEST 2019 -->
<title>WorldEdit (worldedit-core 7.0.0 API)</title>
<meta name="date" content="2019-06-11">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="WorldEdit (worldedit-core 7.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":9,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":9,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../com/sk89q/worldedit/UnknownItemException.html" title="class in com.sk89q.worldedit"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../com/sk89q/worldedit/WorldEditException.html" title="class in com.sk89q.worldedit"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?com/sk89q/worldedit/WorldEdit.html" target="_top">Frames</a></li>
<li><a href="WorldEdit.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.sk89q.worldedit</div>
<h2 title="Class WorldEdit" class="title">Class WorldEdit</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>com.sk89q.worldedit.WorldEdit</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public final class <span class="typeNameLabel">WorldEdit</span>
extends java.lang.Object</pre>
<div class="block">The entry point and container for a working implementation of WorldEdit.

 <p>An instance handles event handling; block, mask, pattern, etc. registration;
 the management of sessions; the creation of <a href="../../../com/sk89q/worldedit/EditSession.html" title="class in com.sk89q.worldedit"><code>EditSession</code></a>s; and more.
 In order to use WorldEdit, at least one <a href="../../../com/sk89q/worldedit/extension/platform/Platform.html" title="interface in com.sk89q.worldedit.extension.platform"><code>Platform</code></a> must be registered
 with WorldEdit using <a href="../../../com/sk89q/worldedit/extension/platform/PlatformManager.html#register-com.sk89q.worldedit.extension.platform.Platform-"><code>PlatformManager.register(Platform)</code></a> on the
 manager retrieved using <a href="../../../com/sk89q/worldedit/WorldEdit.html#getPlatformManager--"><code>getPlatformManager()</code></a>.</p>

 <p>An instance of WorldEdit can be retrieved using the static
 method <a href="../../../com/sk89q/worldedit/WorldEdit.html#getInstance--"><code>getInstance()</code></a>, which is shared among all
 platforms within the same classloader hierarchy.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static org.slf4j.Logger</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#logger">logger</a></span></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#checkMaxBrushRadius-double-">checkMaxBrushRadius</a></span>(double&nbsp;radius)</code>
<div class="block">Checks to see if the specified brush radius is within bounds.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#checkMaxRadius-double-">checkMaxRadius</a></span>(double&nbsp;radius)</code>
<div class="block">Checks to see if the specified radius is within bounds.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#flushBlockBag-com.sk89q.worldedit.extension.platform.Actor-com.sk89q.worldedit.EditSession-">flushBlockBag</a></span>(<a href="../../../com/sk89q/worldedit/extension/platform/Actor.html" title="interface in com.sk89q.worldedit.extension.platform">Actor</a>&nbsp;actor,
             <a href="../../../com/sk89q/worldedit/EditSession.html" title="class in com.sk89q.worldedit">EditSession</a>&nbsp;editSession)</code>
<div class="block">Flush a block bag's changes to a player.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/extension/factory/BlockFactory.html" title="class in com.sk89q.worldedit.extension.factory">BlockFactory</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getBlockFactory--">getBlockFactory</a></span>()</code>
<div class="block">Get the block factory from which new <a href="../../../com/sk89q/worldedit/world/block/BlockStateHolder.html" title="interface in com.sk89q.worldedit.world.block"><code>BlockStateHolder</code></a>s can be
 constructed.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/LocalConfiguration.html" title="class in com.sk89q.worldedit">LocalConfiguration</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getConfiguration--">getConfiguration</a></span>()</code>
<div class="block">Get Worldedit's configuration.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/math/BlockVector3.html" title="class in com.sk89q.worldedit.math">BlockVector3</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getDiagonalDirection-com.sk89q.worldedit.entity.Player-java.lang.String-">getDiagonalDirection</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                    java.lang.String&nbsp;dirStr)</code>
<div class="block">Get the direction vector for a player's direction.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/math/BlockVector3.html" title="class in com.sk89q.worldedit.math">BlockVector3</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getDirection-com.sk89q.worldedit.entity.Player-java.lang.String-">getDirection</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
            java.lang.String&nbsp;dirStr)</code>
<div class="block">Get the direction vector for a player's direction.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/EditSessionFactory.html" title="class in com.sk89q.worldedit">EditSessionFactory</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getEditSessionFactory--">getEditSessionFactory</a></span>()</code>
<div class="block">Get a factory for <a href="../../../com/sk89q/worldedit/EditSession.html" title="class in com.sk89q.worldedit"><code>EditSession</code></a>s.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/util/eventbus/EventBus.html" title="class in com.sk89q.worldedit.util.eventbus">EventBus</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getEventBus--">getEventBus</a></span>()</code>
<div class="block">Get the event bus for WorldEdit.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>com.google.common.util.concurrent.ListeningExecutorService</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getExecutorService--">getExecutorService</a></span>()</code>
<div class="block">Get the executor service.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>static <a href="../../../com/sk89q/worldedit/WorldEdit.html" title="class in com.sk89q.worldedit">WorldEdit</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getInstance--">getInstance</a></span>()</code>
<div class="block">Gets the current instance of this class.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/extension/factory/ItemFactory.html" title="class in com.sk89q.worldedit.extension.factory">ItemFactory</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getItemFactory--">getItemFactory</a></span>()</code>
<div class="block">Get the item factory from which new <a href="../../../com/sk89q/worldedit/blocks/BaseItem.html" title="class in com.sk89q.worldedit.blocks"><code>BaseItem</code></a>s can be
 constructed.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/extension/factory/MaskFactory.html" title="class in com.sk89q.worldedit.extension.factory">MaskFactory</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getMaskFactory--">getMaskFactory</a></span>()</code>
<div class="block">Get the mask factory from which new <a href="../../../com/sk89q/worldedit/function/mask/Mask.html" title="interface in com.sk89q.worldedit.function.mask"><code>Mask</code></a>s
 can be constructed.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/extension/factory/PatternFactory.html" title="class in com.sk89q.worldedit.extension.factory">PatternFactory</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getPatternFactory--">getPatternFactory</a></span>()</code>
<div class="block">Get the pattern factory from which new <a href="../../../com/sk89q/worldedit/function/pattern/Pattern.html" title="interface in com.sk89q.worldedit.function.pattern"><code>Pattern</code></a>s
 can be constructed.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/extension/platform/PlatformManager.html" title="class in com.sk89q.worldedit.extension.platform">PlatformManager</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getPlatformManager--">getPlatformManager</a></span>()</code>
<div class="block">Get the platform manager, where platforms (that implement WorldEdit)
 can be registered and information about registered platforms can
 be queried.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>java.io.File</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getSafeOpenFile-com.sk89q.worldedit.entity.Player-java.io.File-java.lang.String-java.lang.String-java.lang.String...-">getSafeOpenFile</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
               java.io.File&nbsp;dir,
               java.lang.String&nbsp;filename,
               java.lang.String&nbsp;defaultExt,
               java.lang.String...&nbsp;extensions)</code>
<div class="block">Gets the path to a file.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>java.io.File</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getSafeSaveFile-com.sk89q.worldedit.entity.Player-java.io.File-java.lang.String-java.lang.String-java.lang.String...-">getSafeSaveFile</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
               java.io.File&nbsp;dir,
               java.lang.String&nbsp;filename,
               java.lang.String&nbsp;defaultExt,
               java.lang.String...&nbsp;extensions)</code>
<div class="block">Gets the path to a file.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/session/SessionManager.html" title="class in com.sk89q.worldedit.session">SessionManager</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getSessionManager--">getSessionManager</a></span>()</code>
<div class="block">Return the session manager.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code><a href="../../../com/sk89q/worldedit/util/task/Supervisor.html" title="interface in com.sk89q.worldedit.util.task">Supervisor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getSupervisor--">getSupervisor</a></span>()</code>
<div class="block">Get the supervisor.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getVersion--">getVersion</a></span>()</code>
<div class="block">Get the version.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>java.io.File</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#getWorkingDirectoryFile-java.lang.String-">getWorkingDirectoryFile</a></span>(java.lang.String&nbsp;path)</code>
<div class="block">Get a file relative to the defined working directory.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#handleArmSwing-com.sk89q.worldedit.entity.Player-">handleArmSwing</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player)</code>
<div class="block">Called on arm swing.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#handleBlockLeftClick-com.sk89q.worldedit.entity.Player-com.sk89q.worldedit.util.Location-">handleBlockLeftClick</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                    <a href="../../../com/sk89q/worldedit/util/Location.html" title="class in com.sk89q.worldedit.util">Location</a>&nbsp;clicked)</code>
<div class="block">Called on left click.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#handleBlockRightClick-com.sk89q.worldedit.entity.Player-com.sk89q.worldedit.util.Location-">handleBlockRightClick</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                     <a href="../../../com/sk89q/worldedit/util/Location.html" title="class in com.sk89q.worldedit.util">Location</a>&nbsp;clicked)</code>
<div class="block">Called on right click.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#handleRightClick-com.sk89q.worldedit.entity.Player-">handleRightClick</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player)</code>
<div class="block">Called on right click (not on a block).</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#loadMappings--">loadMappings</a></span>()</code>
<div class="block">Load the bundled mappings.</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../com/sk89q/worldedit/WorldEdit.html#runScript-com.sk89q.worldedit.entity.Player-java.io.File-java.lang.String:A-">runScript</a></span>(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
         java.io.File&nbsp;f,
         java.lang.String[]&nbsp;args)</code>
<div class="block">Executes a WorldEdit script.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="logger">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>logger</h4>
<pre>public static final&nbsp;org.slf4j.Logger logger</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getInstance--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInstance</h4>
<pre>public static&nbsp;<a href="../../../com/sk89q/worldedit/WorldEdit.html" title="class in com.sk89q.worldedit">WorldEdit</a>&nbsp;getInstance()</pre>
<div class="block">Gets the current instance of this class.

 <p>An instance will always be available, but no platform may yet be
 registered with WorldEdit, meaning that a number of operations
 may fail. However, event handlers can be registered.</p></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an instance of WorldEdit.</dd>
</dl>
</li>
</ul>
<a name="getPlatformManager--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPlatformManager</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/extension/platform/PlatformManager.html" title="class in com.sk89q.worldedit.extension.platform">PlatformManager</a>&nbsp;getPlatformManager()</pre>
<div class="block">Get the platform manager, where platforms (that implement WorldEdit)
 can be registered and information about registered platforms can
 be queried.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the platform manager</dd>
</dl>
</li>
</ul>
<a name="getEventBus--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEventBus</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/util/eventbus/EventBus.html" title="class in com.sk89q.worldedit.util.eventbus">EventBus</a>&nbsp;getEventBus()</pre>
<div class="block">Get the event bus for WorldEdit.

 <p>Event handlers can be registered on the event bus.</p></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the event bus</dd>
</dl>
</li>
</ul>
<a name="getSupervisor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSupervisor</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/util/task/Supervisor.html" title="interface in com.sk89q.worldedit.util.task">Supervisor</a>&nbsp;getSupervisor()</pre>
<div class="block">Get the supervisor. Internal, not for API use.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the supervisor</dd>
</dl>
</li>
</ul>
<a name="getExecutorService--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutorService</h4>
<pre>public&nbsp;com.google.common.util.concurrent.ListeningExecutorService&nbsp;getExecutorService()</pre>
<div class="block">Get the executor service. Internal, not for API use.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the executor service</dd>
</dl>
</li>
</ul>
<a name="getBlockFactory--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBlockFactory</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/extension/factory/BlockFactory.html" title="class in com.sk89q.worldedit.extension.factory">BlockFactory</a>&nbsp;getBlockFactory()</pre>
<div class="block">Get the block factory from which new <a href="../../../com/sk89q/worldedit/world/block/BlockStateHolder.html" title="interface in com.sk89q.worldedit.world.block"><code>BlockStateHolder</code></a>s can be
 constructed.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the block factory</dd>
</dl>
</li>
</ul>
<a name="getItemFactory--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getItemFactory</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/extension/factory/ItemFactory.html" title="class in com.sk89q.worldedit.extension.factory">ItemFactory</a>&nbsp;getItemFactory()</pre>
<div class="block">Get the item factory from which new <a href="../../../com/sk89q/worldedit/blocks/BaseItem.html" title="class in com.sk89q.worldedit.blocks"><code>BaseItem</code></a>s can be
 constructed.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the item factory</dd>
</dl>
</li>
</ul>
<a name="getMaskFactory--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMaskFactory</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/extension/factory/MaskFactory.html" title="class in com.sk89q.worldedit.extension.factory">MaskFactory</a>&nbsp;getMaskFactory()</pre>
<div class="block">Get the mask factory from which new <a href="../../../com/sk89q/worldedit/function/mask/Mask.html" title="interface in com.sk89q.worldedit.function.mask"><code>Mask</code></a>s
 can be constructed.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the mask factory</dd>
</dl>
</li>
</ul>
<a name="getPatternFactory--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPatternFactory</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/extension/factory/PatternFactory.html" title="class in com.sk89q.worldedit.extension.factory">PatternFactory</a>&nbsp;getPatternFactory()</pre>
<div class="block">Get the pattern factory from which new <a href="../../../com/sk89q/worldedit/function/pattern/Pattern.html" title="interface in com.sk89q.worldedit.function.pattern"><code>Pattern</code></a>s
 can be constructed.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the pattern factory</dd>
</dl>
</li>
</ul>
<a name="getSessionManager--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSessionManager</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/session/SessionManager.html" title="class in com.sk89q.worldedit.session">SessionManager</a>&nbsp;getSessionManager()</pre>
<div class="block">Return the session manager.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the session manager</dd>
</dl>
</li>
</ul>
<a name="getSafeSaveFile-com.sk89q.worldedit.entity.Player-java.io.File-java.lang.String-java.lang.String-java.lang.String...-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSafeSaveFile</h4>
<pre>public&nbsp;java.io.File&nbsp;getSafeSaveFile(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                                    java.io.File&nbsp;dir,
                                    java.lang.String&nbsp;filename,
                                    java.lang.String&nbsp;defaultExt,
                                    java.lang.String...&nbsp;extensions)
                             throws <a href="../../../com/sk89q/worldedit/util/io/file/FilenameException.html" title="class in com.sk89q.worldedit.util.io.file">FilenameException</a></pre>
<div class="block">Gets the path to a file. This method will check to see if the filename
 has valid characters and has an extension. It also prevents directory
 traversal exploits by checking the root directory and the file directory.
 On success, a <code>java.io.File</code> object will be returned.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>dir</code> - sub-directory to look in</dd>
<dd><code>filename</code> - filename (user-submitted)</dd>
<dd><code>defaultExt</code> - append an extension if missing one, null to not use</dd>
<dd><code>extensions</code> - list of extensions, null for any</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a file</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../com/sk89q/worldedit/util/io/file/FilenameException.html" title="class in com.sk89q.worldedit.util.io.file">FilenameException</a></code> - thrown if the filename is invalid</dd>
</dl>
</li>
</ul>
<a name="getSafeOpenFile-com.sk89q.worldedit.entity.Player-java.io.File-java.lang.String-java.lang.String-java.lang.String...-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSafeOpenFile</h4>
<pre>public&nbsp;java.io.File&nbsp;getSafeOpenFile(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                                    java.io.File&nbsp;dir,
                                    java.lang.String&nbsp;filename,
                                    java.lang.String&nbsp;defaultExt,
                                    java.lang.String...&nbsp;extensions)
                             throws <a href="../../../com/sk89q/worldedit/util/io/file/FilenameException.html" title="class in com.sk89q.worldedit.util.io.file">FilenameException</a></pre>
<div class="block">Gets the path to a file. This method will check to see if the filename
 has valid characters and has an extension. It also prevents directory
 traversal exploits by checking the root directory and the file directory.
 On success, a <code>java.io.File</code> object will be returned.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>dir</code> - sub-directory to look in</dd>
<dd><code>filename</code> - filename (user-submitted)</dd>
<dd><code>defaultExt</code> - append an extension if missing one, null to not use</dd>
<dd><code>extensions</code> - list of extensions, null for any</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a file</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../com/sk89q/worldedit/util/io/file/FilenameException.html" title="class in com.sk89q.worldedit.util.io.file">FilenameException</a></code> - thrown if the filename is invalid</dd>
</dl>
</li>
</ul>
<a name="loadMappings--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>loadMappings</h4>
<pre>public&nbsp;void&nbsp;loadMappings()</pre>
<div class="block">Load the bundled mappings.</div>
</li>
</ul>
<a name="checkMaxRadius-double-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkMaxRadius</h4>
<pre>public&nbsp;void&nbsp;checkMaxRadius(double&nbsp;radius)
                    throws <a href="../../../com/sk89q/worldedit/MaxRadiusException.html" title="class in com.sk89q.worldedit">MaxRadiusException</a></pre>
<div class="block">Checks to see if the specified radius is within bounds.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>radius</code> - the radius</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../com/sk89q/worldedit/MaxRadiusException.html" title="class in com.sk89q.worldedit">MaxRadiusException</a></code></dd>
</dl>
</li>
</ul>
<a name="checkMaxBrushRadius-double-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkMaxBrushRadius</h4>
<pre>public&nbsp;void&nbsp;checkMaxBrushRadius(double&nbsp;radius)
                         throws <a href="../../../com/sk89q/worldedit/MaxBrushRadiusException.html" title="class in com.sk89q.worldedit">MaxBrushRadiusException</a></pre>
<div class="block">Checks to see if the specified brush radius is within bounds.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>radius</code> - the radius</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../com/sk89q/worldedit/MaxBrushRadiusException.html" title="class in com.sk89q.worldedit">MaxBrushRadiusException</a></code></dd>
</dl>
</li>
</ul>
<a name="getWorkingDirectoryFile-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getWorkingDirectoryFile</h4>
<pre>public&nbsp;java.io.File&nbsp;getWorkingDirectoryFile(java.lang.String&nbsp;path)</pre>
<div class="block">Get a file relative to the defined working directory. If the specified
 path is absolute, then the working directory is not used.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>path</code> - the subpath under the working directory</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a working directory</dd>
</dl>
</li>
</ul>
<a name="getDirection-com.sk89q.worldedit.entity.Player-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDirection</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/math/BlockVector3.html" title="class in com.sk89q.worldedit.math">BlockVector3</a>&nbsp;getDirection(@Nullable
                                 <a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                                 java.lang.String&nbsp;dirStr)
                          throws <a href="../../../com/sk89q/worldedit/UnknownDirectionException.html" title="class in com.sk89q.worldedit">UnknownDirectionException</a></pre>
<div class="block">Get the direction vector for a player's direction.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>dirStr</code> - the direction string</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a direction vector</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../com/sk89q/worldedit/UnknownDirectionException.html" title="class in com.sk89q.worldedit">UnknownDirectionException</a></code> - thrown if the direction is not known, or a relative direction is used with null player</dd>
</dl>
</li>
</ul>
<a name="getDiagonalDirection-com.sk89q.worldedit.entity.Player-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDiagonalDirection</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/math/BlockVector3.html" title="class in com.sk89q.worldedit.math">BlockVector3</a>&nbsp;getDiagonalDirection(@Nullable
                                         <a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                                         java.lang.String&nbsp;dirStr)
                                  throws <a href="../../../com/sk89q/worldedit/UnknownDirectionException.html" title="class in com.sk89q.worldedit">UnknownDirectionException</a></pre>
<div class="block">Get the direction vector for a player's direction.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>dirStr</code> - the direction string</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a direction vector</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../com/sk89q/worldedit/UnknownDirectionException.html" title="class in com.sk89q.worldedit">UnknownDirectionException</a></code> - thrown if the direction is not known, or a relative direction is used with null player</dd>
</dl>
</li>
</ul>
<a name="flushBlockBag-com.sk89q.worldedit.extension.platform.Actor-com.sk89q.worldedit.EditSession-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>flushBlockBag</h4>
<pre>public&nbsp;void&nbsp;flushBlockBag(<a href="../../../com/sk89q/worldedit/extension/platform/Actor.html" title="interface in com.sk89q.worldedit.extension.platform">Actor</a>&nbsp;actor,
                          <a href="../../../com/sk89q/worldedit/EditSession.html" title="class in com.sk89q.worldedit">EditSession</a>&nbsp;editSession)</pre>
<div class="block">Flush a block bag's changes to a player.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>actor</code> - the actor</dd>
<dd><code>editSession</code> - the edit session</dd>
</dl>
</li>
</ul>
<a name="handleArmSwing-com.sk89q.worldedit.entity.Player-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>handleArmSwing</h4>
<pre>public&nbsp;boolean&nbsp;handleArmSwing(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player)</pre>
<div class="block">Called on arm swing.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the swing was handled</dd>
</dl>
</li>
</ul>
<a name="handleRightClick-com.sk89q.worldedit.entity.Player-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>handleRightClick</h4>
<pre>public&nbsp;boolean&nbsp;handleRightClick(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player)</pre>
<div class="block">Called on right click (not on a block).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the right click was handled</dd>
</dl>
</li>
</ul>
<a name="handleBlockRightClick-com.sk89q.worldedit.entity.Player-com.sk89q.worldedit.util.Location-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>handleBlockRightClick</h4>
<pre>public&nbsp;boolean&nbsp;handleBlockRightClick(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                                     <a href="../../../com/sk89q/worldedit/util/Location.html" title="class in com.sk89q.worldedit.util">Location</a>&nbsp;clicked)</pre>
<div class="block">Called on right click.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>clicked</code> - the clicked block</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>false if you want the action to go through</dd>
</dl>
</li>
</ul>
<a name="handleBlockLeftClick-com.sk89q.worldedit.entity.Player-com.sk89q.worldedit.util.Location-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>handleBlockLeftClick</h4>
<pre>public&nbsp;boolean&nbsp;handleBlockLeftClick(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                                    <a href="../../../com/sk89q/worldedit/util/Location.html" title="class in com.sk89q.worldedit.util">Location</a>&nbsp;clicked)</pre>
<div class="block">Called on left click.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>clicked</code> - the clicked block</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>false if you want the action to go through</dd>
</dl>
</li>
</ul>
<a name="runScript-com.sk89q.worldedit.entity.Player-java.io.File-java.lang.String:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>runScript</h4>
<pre>public&nbsp;void&nbsp;runScript(<a href="../../../com/sk89q/worldedit/entity/Player.html" title="interface in com.sk89q.worldedit.entity">Player</a>&nbsp;player,
                      java.io.File&nbsp;f,
                      java.lang.String[]&nbsp;args)
               throws <a href="../../../com/sk89q/worldedit/WorldEditException.html" title="class in com.sk89q.worldedit">WorldEditException</a></pre>
<div class="block">Executes a WorldEdit script.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>f</code> - the script file to execute</dd>
<dd><code>args</code> - arguments for the script</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../com/sk89q/worldedit/WorldEditException.html" title="class in com.sk89q.worldedit">WorldEditException</a></code></dd>
</dl>
</li>
</ul>
<a name="getConfiguration--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConfiguration</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/LocalConfiguration.html" title="class in com.sk89q.worldedit">LocalConfiguration</a>&nbsp;getConfiguration()</pre>
<div class="block">Get Worldedit's configuration.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a configuration</dd>
</dl>
</li>
</ul>
<a name="getEditSessionFactory--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEditSessionFactory</h4>
<pre>public&nbsp;<a href="../../../com/sk89q/worldedit/EditSessionFactory.html" title="class in com.sk89q.worldedit">EditSessionFactory</a>&nbsp;getEditSessionFactory()</pre>
<div class="block">Get a factory for <a href="../../../com/sk89q/worldedit/EditSession.html" title="class in com.sk89q.worldedit"><code>EditSession</code></a>s.</div>
</li>
</ul>
<a name="getVersion--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getVersion</h4>
<pre>public static&nbsp;java.lang.String&nbsp;getVersion()</pre>
<div class="block">Get the version.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the version of WorldEdit</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../com/sk89q/worldedit/UnknownItemException.html" title="class in com.sk89q.worldedit"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../com/sk89q/worldedit/WorldEditException.html" title="class in com.sk89q.worldedit"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?com/sk89q/worldedit/WorldEdit.html" target="_top">Frames</a></li>
<li><a href="WorldEdit.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
